/**
 * @module ctt
 * @submodule scheduled-recording-wizard-page-controller
 */
(function() {
var Event = dixim.event.Event;
var WizardPageController = dixim.ctt.WizardPageController;
var ScheduledRecordingWizardPageView = dixim.ctt.ScheduledRecordingWizardPageView;
var ConfirmationWizardPageController = dixim.ctt.ConfirmationWizardPageController;
var ConfirmationWizardMoveItemController = dixim.ctt.ConfirmationWizardMoveItemController;

var ScheduledRecordingWizardPageController;
var prototype;
var superConstructor;

/**
 * @class ScheduledRecordingWizardPageController
 * @extends WizardPageController
 * @constructor
 * @param {Object} configs
 */
ScheduledRecordingWizardPageController = function(configs) {
  WizardPageController.call(this, configs);
};
dixim.inherit(ScheduledRecordingWizardPageController, WizardPageController);
dixim.ctt.ScheduledRecordingWizardPageController = ScheduledRecordingWizardPageController;
prototype = ScheduledRecordingWizardPageController.prototype;
superConstructor = ScheduledRecordingWizardPageController.superConstructor;

prototype._createView = function() {
  var v;
  var w = this._wizard;

  v = new ScheduledRecordingWizardPageView({
    isDownloadMoveIn: w.getRegistryEntry('isDownloadMoveIn')
  });
  this._view = v;
};

prototype.start = function() {
  var v;

  if (!!!this._view) {
    this._createView();
  }

  v = this._view;
  v.addEventListener('cancel', this._didCancel, this);
  v.addEventListener('next', this._didClickNext, this);
  v.addEventListener('back', this._didClickBack, this);

  superConstructor.prototype.start.call(this);
};

prototype._didClickNext = function(e) {
  var wizard = this._wizard;
  var date = null;
  var scheduled;
  var vc;
  var targets;

  scheduled = this._view.getSelectedMethod() === 'scheduled';
  if (scheduled) {
    date = this._view.getSelectedDate();
  }
  wizard.setRegistryEntry('scheduled', scheduled);
  wizard.setRegistryEntry('scheduledDate', date);

  if (wizard.getRegistryEntry('isExistMoveItem')) {
    vc = new ConfirmationWizardMoveItemController();
  } else {
    vc = new ConfirmationWizardPageController();
  }
  wizard.pushViewController(vc);
};

prototype._didClickBack = function(e) {
  var vc;

  vc = this._wizard.popViewController();
  vc.destroy();
};

}());
